                    INCLUDE  "VECTREX.I"                  ; vectrex function includes
                    INCLUDE  "macro.i"                    ; vectrex function includes

;***************************************************************************
; Variable / RAM SECTION
;***************************************************************************
; insert your variables (RAM usage) in the BSS section
; user RAM starts at $c880 
                    BSS      
                    ORG      $c880                        ; start of our ram space 

; Structures
                    struct   RocketEmitter
                        ds       Y_POS, 2 
                        ds       BEHAVIOUR, 2 
                        ds       NEXT_OBJECT, 2 
                        ds       X_POS, 2 
                        ds       Y_VEL, 1 
                        ds       X_VEL, 1 
                        ds       AGE, 1 
                    end struct 
                    struct   VelocityParticle
                        ds       Y_POS, 2 
                        ds       BEHAVIOUR, 2 
                        ds       NEXT_OBJECT, 2 
                        ds       X_POS, 2 
                        ds       Y_VEL, 1 
                        ds       X_VEL, 1 
                        ds       AGE, 1 
                    end struct 


; RAM
; jump back addresses
; for "last" behaviour routine
PARTICLES_DONE_A    ds       2                            ; 
PARTICLES_DONE      =        PARTICLES_DONE_A-2 
PLIST_COMPARE_ADDRESS: 
;
u_offset1           =        -NEXT_OBJECT                 ; behaviour offset is determined by next structure element 
random_a            ds       1                            ; vars for own "random" - is much better than the internal BIOS one! 
random_b            ds       1                            ; see https://www.electro-tech-online.com/threads/ultra-fast-pseudorandom-number-generator-for-8-bit.124249/ 
random_c            ds       1 
random_x            ds       1 
tmp1 ds 1
buttonStatus ds 1
;
PARTICLE1_MAX_COUNT  =       70                          ; max with below RAM 
;
plist_empty_head    ds       2                            ; if empty these contain a value that points to a RTS, smaller than OBJECT_LIST_COMPARE_ADDRESS 
plist_objects_head  ds       2                            ; if greater OBJECT_LIST_COMPARE_ADDRESS, than this is a pointer to a RAM location of an Object 
pobject_list        ds       VelocityParticle*PARTICLE1_MAX_COUNT 
pobject_list_end    ds       0 
;
;
; 
