

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; new list object to U
; destroys d, u 
newObject                                                 ;#isfunction  
                    ldu      plist_empty_head 
                    cmpu     #PLIST_COMPARE_ADDRESS 
                    bls      cs_done_no 
                                                          ; set the new empty head 
                    ldd      NEXT_OBJECT,u              ; the next in out empty list will be the new 
                    std      plist_empty_head            ; head of our empty list 
                                                          ; load last of current object list 
; the old head is always our next
                    ldd      plist_objects_head 
                    std      NEXT_OBJECT,u 
; newobject is always head
                    stu      plist_objects_head 
cs_done_no 
                    rts      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; this macro is placed at the end of each possible "remove" exit
; it stores the just removed object at the head of the "empty" list and 
; sets up its "next" pointer
UPDATE_EMPTY_LIST  macro  
                    ldy      plist_empty_head            ; set u free, as new free head 
                    sty      NEXT_OBJECT,x              ; load to u the next linked list element 
                    stx      plist_empty_head 
                    endm     
;
destroyPObject                                           ;#isfunction  
; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; in ds+u_offset1 pointer to the object that must be removed
; destroys x, y 
; puls from ds the next object behaviour
; 
; this version is called at the end of an explosion called by "behaviours"
;
                    leax     u_offset1,u                  ; x -> pointer object struture (correction of offset) 
                    cmpx     plist_objects_head          ; is it the first? 
                    bne      was_not_first_enem           ; no -> jump 
was_first_enem 
                    ldu      NEXT_OBJECT,x              ; s pointer to next objext 
                    stu      plist_objects_head          ; the next object will be the first 
                    bra      pRemoveDone 

was_not_first_enem                                        ;        find previous, go thru all objects from first and look where "I" am the next... 
                    ldy      plist_objects_head          ; start at list head 
try_next_enem 
                    cmpx     NEXT_OBJECT,y              ; am I the next object of the current investigated list element 
                    beq      found_next_switch_enem       ; jup -> jump 
                    ldy      NEXT_OBJECT,y              ; otherwise load the next as new current 
                    bra      try_next_enem                ; and search further 

found_next_switch_enem 
                    ldu      NEXT_OBJECT,x              ; we load "our" next object to s 
                    stu      NEXT_OBJECT,y              ; and store our next in the place of our previous next and thus eleminate ourselfs 
pRemoveDone 
                    UPDATE_EMPTY_LIST                ; and clean up the empties 
; do a clean ending - which is usually done at the end of "SmartDraw"
;                    lda      #$7f 
;                    STa      <VIA_t1_cnt_lo 
                    _ZERO_VECTOR_BEAM  
                    MY_MOVE_TO_A_END  
                    pulu     d,pc                         ; (D = y,x, X = vectorlist) 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
